import swarm.simtoolsgui.*;
import swarm.gui.*;
import swarm.space.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import swarm.*;

public class ObserverSwarm extends GUISwarmImpl{
	public int displayFrequency;
	public int worldSizeX;
	public int worldSizeY;
	//bz reaction values
	public int k1, k2, constant_g, illness_n;
	public int surrounding;
	public int self_multiplation;
	//border condition
	public boolean border;
	//defect values
	public boolean defects;
	public int dx, dy;
	//rectangle values
	public int startx, starty;
	public int width, height;

	//color values
	public int Rstart, Rend;
	public int Bstart, Bend;
	public int Gstart, Gend;
	
	ActionGroup displayActions;
	Schedule displaySchedules;
	
	Colormap colorMap;
	ZoomRaster worldRaster;
	ConwayWorld2 conwayWorld;
	
	Value2dDisplay valueDisplay;
	
	public ObserverSwarm(Zone aZone){
		super(aZone);
		
		// Fill in the relevant parameters
		displayFrequency=1;
		worldSizeX = 120;
		worldSizeY = 120;
		k1 = 1;
		k2 = 1;
		constant_g = 10;
		illness_n = 50;
		surrounding = 255;
		self_multiplation = 1;
		border = true;
		defects = false;
		dx = 0;
		dy = 0;
		startx = 0;
		starty = 0;
		width = 0;
		height = 0;
		Rstart = 102;
		Rend = 102;
		Gstart = 0;
		Gend = 250;
		Bstart = 255;
		Bend = 255;
		
		
		EmptyProbeMap probeMap;
		probeMap = new EmptyProbeMapImpl(aZone, this.getClass());
		
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("displayFrequency",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("border",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("worldSizeX",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("worldSizeY",this.getClass()));

		//make probemap of bz reaction factors
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("k1",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("k2",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("constant_g",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("illness_n",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("surrounding",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("self_multiplation",this.getClass()));
		
		//make probe of color setting
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("Rstart",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("Rend",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("Gstart",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("Gend",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("Bstart",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("Bend",this.getClass()));
		
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForMessage$inClass("buildObjects",this.getClass()));
/*
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("defects",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("dx",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("dy",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("startx",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("starty",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("width",this.getClass()));
		probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass("height",this.getClass()));
*/		
//		probeMap.addProbe(Globals.env.probeLibrary.getProbeForMessage$inClass("eraseConway",this.getClass()));
		
		Globals.env.probeLibrary.setProbeMap$For(probeMap,this.getClass());
		
	}
	
	public Object buildObjects(){
		super.buildObjects();
		int i;
		int N;
		double tempR, tempG, tempB;
		
//		Object ayata = new GUISwarmImpl();
//		ayata.super.buildObjects();
		
		N = 251;
		
		Globals.env.createArchivedProbeDisplay(this, "observerSwarm");
		getControlPanel().setStateStopped();

//		ayata.Globals.env.createArchivedProbeDisplay(this, "observerSwarm");
//		Globals.env.createArchivedProbeDisplay(this, "observerSwarm");

		colorMap = new ColormapImpl(this);
		/*
		for (i=1;i<50;i++) {
			tempi = (byte)i;
			colorMap.setColor$ToName(tempi,"blue");
		}
		colorMap.setColor$ToName((byte)0,"white");
		colorMap.setColor$ToName((byte)50,"red");
		 */
/*
		for (i=0;i<51;i++){
			colorMap.setColor$ToGrey((byte)i,(double)i/50);
		}
	*/
		
		//set color of defect
		colorMap.setColor$ToRed$Green$Blue((byte)255,1.0,1.0,1.0);
		
		//set color
		for (i=0;i<N;i++){
			tempR = ((double) (Rend-Rstart)*i/N+Rstart)/255;
			tempG = ((double) (Gend-Gstart)*i/N+Gstart)/255;
			tempB = ((double) (Bend-Bstart)*i/N+Bstart)/255;
			colorMap.setColor$ToRed$Green$Blue((byte)i,tempR,tempG,tempB);
		}
		
		worldRaster = new ZoomRasterImpl(this);
		worldRaster.setColormap(colorMap);
		worldRaster.setZoomFactor(4);
		worldRaster.setWidth$Height(worldSizeX, worldSizeY);
		worldRaster.setWindowTitle("BZ reaction");
		worldRaster.pack();

		
		conwayWorld = new ConwayWorld2(this, worldSizeX, worldSizeY);
				
		conwayWorld.setSizeX$Y(worldSizeX,worldSizeY);
		conwayWorld.setParam(k1,k2,constant_g,illness_n,surrounding,self_multiplation);
		conwayWorld.setBorder(border);
		conwayWorld.setDefect(defects,dx,dy);
		conwayWorld.setRectangle(startx, starty, width, height);
		//conwayWorld.setObserver(this);
		
		try{
			valueDisplay = new Value2dDisplayImpl(this, worldRaster, colorMap, conwayWorld);
		}catch(Exception e){
			System.err.println("Exception: " + e.getMessage());
			System.exit(1);
		}

		try{
			worldRaster.setButton$Client$Message(3, conwayWorld, new Selector(conwayWorld.getClass(), "swapColorAtX$Y",false));
		}catch(Exception e){
			System.err.println("Exception: " + e.getMessage());
			System.exit(1);
		}
		return this;
	}
	public Object buildActions(){
		
		displayActions = new ActionGroupImpl(this);
		
		// Schedule up the methods to draw the display of the world
		try{
			displayActions.createActionTo$message(valueDisplay, new Selector(valueDisplay.getClass(),"display",false));
			displayActions.createActionTo$message(worldRaster, new Selector(worldRaster.getClass(),"drawSelf",false));
			displayActions.createActionTo$message(conwayWorld, new Selector(conwayWorld.getClass(),"stepRule2",false));
			displayActions.createActionTo$message(conwayWorld, new Selector(conwayWorld.getClass(),"Defect",false));
			displayActions.createActionTo$message(conwayWorld, new Selector(conwayWorld.getClass(),"Rectangle",false));
			displayActions.createActionTo$message(getActionCache(), new Selector(getActionCache().getClass(),"doTkEvents",true));
		}catch (Exception e){
			System.err.println("Exception: " + e.getMessage());
			System.exit(1);
		}
		displaySchedules = new ScheduleImpl(this,displayFrequency);
		displaySchedules.at$createAction(0,displayActions);
		
		return this;
	}
	
	public Activity activateIn(Swarm context){
		super.activateIn(context);
		
		displaySchedules.activateIn(this);
		
		return getActivity();
	}
	
	public Object eraseConway(){
//		if(conwayWorld.getClass()!=null)
			conwayWorld.eraseAll();
		return this;
	}
}